{{
// modified by CPDT for F12 switch TV VGA

// PHENIX SOURCE CODE
// PHENIX SOURCE CODE
// PHENIX SOURCE CODE
// PHENIX SOURCE CODE
// PHENIX SOURCE CODE
// PHENIX SOURCE CODE
// PHENIX SOURCE CODE
// PHENIX SOURCE CODE
// PHENIX SOURCE CODE
// PHENIX SOURCE CODE
// PHENIX SOURCE CODE
// PHENIX SOURCE CODE
// PHENIX SOURCE CODE
// PHENIX SOURCE CODE
// PHENIX SOURCE CODE
// PHENIX SOURCE CODE
// PHENIX SOURCE CODE
// PHENIX SOURCE CODE



///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// SD3.01 FATEngine Demo
//
// Author: Kwabena W. Agyeman
// Updated: 1/2/2011
// Designed For: P8X32A
// Version: 1.0
//
// Copyright (c) 2011 Kwabena W. Agyeman
// See end of file for terms of use.
//
// Update History:
//
// v1.0 - Original release - 7/27/2010.
// v1.1 - Updated code for new file system driver - 1/2/2011.
// Nyamekye

 modifications by J. Moxham Dr_Acula to create KyeDOS v3. Pins setup for the Dracblade (similar to the Propeller Demo Board)
 - name this file KyeDOS3
 - changed sd pins to 12,13,14,15. WP and CD = -1
 - RTC DAT and CLK -1
 - Audio and Microphone pins all set to -1
 comment out   'adc: "PCM2.1_ADCEngine.spin"   and compile to find all PUBs referenced by this
 comment out adcengine start and PRI programTapeWavFile  and   dac: "PCM2.1_DACEngine.spin"  and PRI programPlayWavFile
 comment out programPlayWavFile(stringPointer) and  programTapeWavFile(stringPointer) and PRI scope
 comment out   if(_VGA_Enabled) group
 startup is   ifnot( fat.FATEngineStart(_SD_DO, _SD_CLK, _SD_DI, _SD_CS, _SD_WP, _SD_CD, _RTC_DAT, _RTC_CLK, -1) and {
       } com.COMEngineStart(_receiverPin, _transmitterPin, _baudRateSpeed))
  comment out   'bmp: "VGA64_BMPEngine.spin"   _VGA_BG_Color = bmp#black   _VGA_FG_Color = bmp#green      
  add OBJ   VT100: "VGA_1024_VT100"       ' VGA VT100 Terminal Driver
  copied VGA_1024_text.spin and VGA_80x40.spin to the working folder
  added VT100 startup code - now have a blinking white cursor on a blue screen. 80x40 text.
  commented out '  long scopeSwtich, scopeStack[17], scopeHeap[((_VGA_H_Res * _VGA_V_Res) * 2) / 32]  
  (need to watch memory F8 here while adding more objects to the OBJ section)
  added   key : "Pocketerm_Keyboard"           ' pocketerm keyboard
  added   lcd : "DracLCD"                     ' 20x4 LCD driver for dracblade
  added   delay: "Timing"                     ' for millisecond delays
  added the keyboard startup   key.startx(26, 27, %100, 40)             'Start Keyboard Driver  pin,pin,num,repeatrate
  added lcd.start    - this is dracblade specific with a 20x4 local keyboard. You can leave this out if not used
  commented out the existing .com driver. There is a bug with xmodem with corrupted bytes above 100 in the buffer, this does not show up with typing as the buffer never gets this full
  added 2 port serial driver (variation on Tim Moore's code). Copied object to current directory    sio     : "pcFullDuplexSerial2FC"  
  F8 now fails with all instances of .com
  Added some printstring routines that send data to VGA and to the serial port and the LCD display and do CRLF properly
  added sio.addport. removed startup for the .com
  global search and replace "com.transmitstring" to "printstring"
  global search and replace "com.transmitbyte" to "printchar"
  edited a line with #comquotation marks. Keep doing F8 to find errors
  edited PRI shellline so it can accept Backspace and can read from keyboard and serial port
  found that the string engine syntax has changed. putcharacter is now buildstring
  found that the string engine syntax has chnaged. getcharacters is now builtstring
  rewrote PRI shelldecision
  replaced instances of quotationmarks from the serial driver to a local variable quote (ascii 34)
  added local contstants Horizontal_tab, Linefeed, CarriageReturn. Did global find/replace
  F8 finally compiles with no errors!
  added sio.start, print signon message
  added PRI DisplayBinaryFiles. Changed to the new syntax for reading entries
  ** edited the string engine - added PUB endsWithString(stringToSearch, stringToFind) '' 12 Stack Longs 
  baud rate 38400 for testing
  comment out '  _newLineCharacter = 13  , replace with crlf
  go through the DAT shellProgramHelpStrings and replace _newlinecharacter with byte 13 and byte 10  
  commented out the wav file commands in the help section (can always uncomment them later) amd the PRI
  replace instances of     PrintChar(_newLineCharacter) with crlf or with printstringcr. Multiple instances
  removed "are you sure" from the boot command
  edited the 'help' commands so they each fit on one line
  moved the check for mounted card after every command to above the loop so only checks once.
  working on a very strange bug in programDIR - if send more than a certain number of tabs to the VT100 the whole spin program shuts down. Possibly overrunning a buffer and overwriting code. Need a better solution to line up files in columns
  also shows up with the LS command.
  added a constant _LCD_Enabled so can easily turn this off for boards that do not have it
  added a constant for VGA_enabled and also Serial_Enabled - can turn each of these on or off
  added a printdecimal for debugging
  added running .exe files, eg to run MOVIE.EXE type movie see programCommand
  added simple wildcards to the "DIR" command, so can type dir *.exe and see just these files
  changed the command line (.exe files) so it stores the command line in a text file COMMAND.TXT ready for other programs to read.
 
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
}}

CON

  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000

  _leftChannelVolume = 32
  _rightChannelVolume = 32

  _baudRateSpeed = 115200 ' Teraterm does not work at this speed. Use hyperterminal or other programs
'  _newLineCharacter = 13
  _clearScreenCharacter = 16
  _homeCursorCharacter = 1

  _receiverPin = 31
  _transmitterPin = 30

  _RTC_DAT = -1 ' -1 ifnot installed.
  _RTC_CLK = -1 ' -1 ifnot installed.

  _TV_Pin = 12 ' group of 3 pins starting at pin 16

  _VGA_PinGroup = 2

  _LCD_Enabled = false ' false or true for 20x4 LCD display
  _Serial_Enabled = false ' send output to serial port 

  _leftChannelAudioPin = -1 ' -1 ifnot installed.
  _rightChannelAudioPin = -1 ' -1 ifnot installed.

  _leftMicFeedBackPin = -1 ' -1 ifnot installed.
  _leftMicInputPin = -1 ' -1 ifnot installed.

  _rightMicFeedBackPin = -1 ' -1 ifnot installed.
  _rightMicInputPin = -1 ' -1 ifnot installed.

  ' STANDARD PINS 
   {
  _SD_DO = 0
  _SD_CLK = 1
  _SD_DI = 2
  _SD_CS = 3
  _SD_WP = -1 ' -1 ifnot installed.
  _SD_CD = -1 ' -1 ifnot installed.
  }
  ' PHENIX PINS - Shared SPI bus with PIC
  
  _SD_DO = 10   ' sensitive
  _SD_CLK = 11   '11    'sensitive
  _SD_DI = 9      'not so sensitive   DI = data in from the SD card perspective
  _SD_CS = 15
  _SD_WP = -1 ' -1 ifnot installed.
  _SD_CD = -1 ' -1 ifnot installed.
 
  

  PROPPORT_TEST_LENGTH = 2000


'BODGE PINS
{
  _SD_DO = 10   ' sensitive
  _SD_CLK = 1   '11    'sensitive
  _SD_DI = 9      'not so sensitive   DI = data in from the SD card perspective
  _SD_CS = 15
  _SD_WP = -1 ' -1 ifnot installed.
  _SD_CD = -1 ' -1 ifnot installed.
 }
 
'  Videopin = 16
  Keypin   = 26

 
  Quote = 34
  Horizontal_Tab = 9
  Line_Feed = 10
  Carriage_Return =13

OBJ

  fat: "SD3.01_FATEngine.spin"
  taf: "SD3.01_FATEngine.spin"
  rtc: "DS1307_RTCEngine.spin"
  'com: "RS232_COMEngine.spin"
  str: "ASCII0_STREngine.spin"
  'adc: "PCM2.1_ADCEngine.spin"
  'dac: "PCM2.1_DACEngine.spin"
  'bmp: "VGA64_BMPEngine.spin"
  vt100: "VGA_1024_VT100"       ' VGA VT100 Terminal Driver
  text:  "aigeneric_driver"
  key : "Pocketerm_Keyboard"           ' pocketerm keyboard

 ' mouse: "mouse_010"  ' from CHAMELEON driver
  
  'key : "webtv_keyboard"
'  lcd : "DracLCD"                     ' 20x4 LCD driver for dracblade
  delay: "Timing"                     ' for millisecond delays
  sio     : "pcFullDuplexSerial2FC" 

VAR
'
'  long scopeSwtich, scopeStack[17], scopeHeap[((_VGA_H_Res * _VGA_V_Res) * 2) / 32]
   byte CommandLine[80] ' complete command line as typed in
   byte LineOfText1[80] ' general purpose string buffer
   byte LineOfText2[80] ' general purpose string buffer
   byte LineOfText3[80] ' general purpose string buffer


   byte _TV_Enabled '= true ' TV display on
   byte _VGA_Enabled '= false ' VGA display on

 '  long fpga_buffer[PROPPORT_TEST_LENGTH]
    long portval
    
 
PUB shell | fatstarted_flag



fatstarted_flag := 1
 ifnot( fat.FATEngineStart(_SD_DO, _SD_CLK, _SD_DI, _SD_CS, _SD_WP, _SD_CD, _RTC_DAT, _RTC_CLK, -1))
'        com.COMEngineStart(_receiverPin, _transmitterPin, _baudRateSpeed)) 
'        adc.ADCEngineStart(_leftMicInputPin, _leftMicFeedBackPin, _rightMicInputPin, _rightMicFeedBackPin, 16_000)
'        dac.DACEngineStart(_leftChannelAudioPin, _rightChannelAudioPin, 0) )
         fatstarted_flag := 0



 'delay.pause1ms(5000)    
key.startx(keypin, keypin+1, %100, 40)             'Start Keyboard Driver  pin,pin,num,repeatrate
  sio.AddPort(0, _receiverPin, _transmitterPin, -1, -1, 0, 0, _baudRateSpeed)
  'sio.AddPort(1, _port2receiverPin, _port2transmitterPin, -1, -1, 0, 0, 120000) ' shamcom works 108000 to 120000 (teraterm can't do 112800 even though it can select it)
  'sio.tx(1,65)    ' test port 2
  
'  if(_LCD_Enabled)

'DIRA[15] := 1 ' set to output
    'repeat 6
  '  OUTA[25] := !OUTA[25]
  '  repeat 25_000    lcd.start ' start the LCD display


'  repeat
'    if key.gotkey <>0         ' scan both the local keyboard and the com port
'        result:=key.getkey
         'text.dec(result)
'    OUTA[15] := 0
'    OUTA[15] := 1
'  until result ==  219
                                             ' start the cursor
     
    



  'DIRA[15] := 1 ' set to output

  'repeat
  '  if key.gotkey <>0         ' scan both the local keyboard and the com port
  '       result:=key.getkey
  '       'text.dec(result)
  '  OUTA[15] := 0
  '  OUTA[15] := 1
  'until result ==  219

  'DIRA[15] := 0 ' set to output





   
'  dac.leftChannelVolume(_leftChannelVolume)
'  dac.rightChannelVolume(_rightChannelVolume)
                     ' clear the screen
 
'     reboot
 
  'delay.pause1ms(5000)


         
_TV_Enabled := false
  _VGA_Enabled := true

  if(_TV_Enabled)
    text.start(_TV_Pin)                                 ' start the vga driver VGA starts on pin 16
    text.startcursor                                     ' start the cursor
    settvcolors                       ' Blue_White  blue =3/4 power 10, white =full                                  
    text.cursorset(5)                                    ' cursor type 5
    text.clearscreen                                     ' clear the screen

       'text.str(string("Testing for SD card",13,10))        ' helpful message if card is out, better than just a blank screen                                  
  if(_VGA_Enabled)
    VT100.start(16)                                       ' start the vga driver VGA starts on pin 16
    VT100.startcursor                                     ' start the cursor
    setvgacolors                       ' Blue_White  blue =3/4 power 10, white =full                                  
    VT100.cursorset(5)                                    ' cursor type 5
    VT100.clearscreen                  
  
sio.start             ' start the com port  note can't print anything to screen till sio.start unless only do to vga screen
 

'doFPGA

      
if fatstarted_flag == 1
  PrintStringCR(string("SD Test"))  ' helpful message if card is out, better than just a blank screen
  fat.mountPartition(0)     ' mount the sd card

if(_TV_Enabled)
  text.clearscreen                                     ' if the sd card is not inserted, will leave the message on the screen as a reminder. If it is inserted, start with a blank screen
if(_VGA_Enabled)
  VT100.clearscreen                                     ' clear the screen

if fatstarted_flag == 0
    PrintStringCR(string("FAT FAiled"))
    crlf

DisplayBanner
PrintStringCR(string("Type HELP for a list of commands."))
crlf
 
sio.rxflush(0)                                      ' in case try to send an xmodem transfer

  ifnot(fat.partitionMounted)
    printstring(string("Card Not Mounted "))   
    
 ' DisplayBinaryFiles                    ' display all files ending in .BIN

  repeat

    result := shellLine(string(">"))
    'printstring(string("Running command: ")) ' commands run so quickly no need to print this
    'printstring(result)
    str.copy(result,@commandline)' save for later on if this is a command line with parameters eg "xmodem r filename.txt"
    crlf

    result := \shellCommands(result)
    printstring(result)
    crlf

    if(fat.partitionError)
      crlf
PRI  setvgacolors
  VT100.color(%00000000_11111100)

PRI  settvcolors
  text.color(%00000000_11001100)

PRI DisplayBanner

  crlf
  PrintStringCR(string("  ___  __  ___  _  ___ ___    OO"))
  PrintStringCR(string(" |    |  ||    / \  | |     O __ O"))
  PrintStringCR(string(" |    |-- |-- |---| | |--    |  |"))
  PrintStringCR(string(" |___ |  \|___|   | | |___   |__|"))
  PrintStringCR(string("                            uLynx"))
  crlf
  PrintStringCR(string("   Version 0.48    Pete Todd 2013"))
  PrintStringCR(string("KyeDOS v3.01 - K.W. Agyeman & J. Moxham"))
  crlf
 'VT100.rowcolor(3,8)


PRI shellCommands(stringPointer)

  stringPointer := str.tokenizeString(stringPointer)

  programClear(stringPointer)
  programEcho(stringPointer)

  programReboot(stringPointer)
  programHelp(stringPointer)

 ' programMount(stringPointer)
 ' programUnmount(stringPointer)

  programFreeSpace(stringPointer)
  programUsedSpace(stringPointer)

 ' programList(stringPointer)
  programDIR(stringPointer)
  'programConcatenate(stringPointer)

  programChangeDirectory(stringPointer)
  programChangeAttributes(stringPointer)

  programMove(stringPointer)
  programRemove(stringPointer)
  programEra(stringPointer)  ' same as programremove

  programMakeFile(stringPointer)
  programMakeDirectory(stringPointer)

  programCopy(stringPointer)
 ' programDifference(stringPointer)

  programBoot(stringPointer)
 ' programFormat(stringPointer)
 ' programMouseBoot(stringPointer)
 
 ' programDate(stringPointer)                                      
 ' programTime(stringPointer)
 '  programRamSet(stringPointer)
'  programRamGet(stringPointer)

'  programSQW(stringPointer)
'  programOUT(stringPointer)

'  programPlayWavFile(stringPointer)
'  programTapeWavFile(stringPointer)

  programDump(stringPointer)
 ' programTest(stringPointer)

  programCommand(StringPointer) ' is it a command ie a .exe file?

  abort string("ugh?")
  crlf
{
PRI shellLine(prompt)

  printstring(prompt)

  repeat
    result := com.receivedByte
    str.buildString(result)
  while((result <> carriage_return) and (result <> carriage_return) and (result <> com#null))

  return str.trimString(str.builtString(true))
}

PRI doDIR

      result := \shellCommands(string("DIR"))

      printstring(result)
      crlf
      PrintChar(">")

return
         
 'set bit
 'AnyVariable |= (|< RequiredBitNumber)
  'reset 0 bit
  'AnyVariable &= !(|< RequiredBitNumber)
  'toggle bit
  'AnyVariable ^= (|< RequiredBitNumber)

    'get status
   'BitStatus := X & (|< RequiredBitNumber)
     '  DIRA[9] := 0   'set p9 as input

  '    INA |= |<10 | |<3   'sets bits 10 and 3 HI

 ' portval := INA[0]+INA[25]+INA[2..7]
        ' diff_flag := 0
        ' sVT100.str(string("Portval is: "))
        ' VT100.dec(INA[7..2])


 
PRI doFPGA | bread, portval2, oldportval, diff_flag, clockpin,syncpin, d1port , d2port, d3port , xx
   
       'HARDCODED BELOW
'      d1port := 15  '_SD_DO
 '     DIRA[d1port] := 0   'set p10 as input   (these SD lines wil have pullups one them)
   '    d2port := _SD_CLK
   '   DIRA[d2port] := 0   'set p11 as input
  '    d3port := _SD_DI
  '    DIRA[d3port] := 0   'set p9 as input
      DIRA[15] := 0
      DIRA[25] := 0
      DIRA[9] := 0
      DIRA[10] := 0
       DIRA[11] := 0
       DIRA[7..0] := 0
       clockpin := 15
       syncpin := 25
       
  '  repeat
  '    portval := INA[15]
  '    'OUTA[15] := portval
  '     VT100.dec(portval)
  

    ' d2port := VT100.addr
     

    VT100.str(string("Waiting for port data ")) 

    bread := 0
    
      
    repeat
     
      
 '     if key.keystate(194)
 '         tv_on

 '         repeat
'                  
'          until !key.keystate(194)
      'VT100.str(string("Sync Wait."))


      'wait for sync
      repeat
             portval := INA[syncpin]
      while  portval == 0   'wait for P25 HI 

      repeat
             portval := INA[syncpin] 
      while  portval == 1   'wait for P25 low 
          
          
      xx := 0
              'repeat
      
  '         repeat
   '                    portval := INA 

    '       while  (portval  & (|< clockpin))    'test for P25 HI
          '          repeat
          '            portval2 := INA 
          '          while  ((portval2  & (|< clockpin)) == 0)    'test for P25 LOW
                    
             ' while ((portval & $ff) <> 0)
             
          repeat PROPPORT_TEST_LENGTH
             'wait for PORTCLOCK HI
      {
             repeat
               portval2 := INA 
             while  ((portval2  & (|< 9)) == 0)    'test for P9 LOW
      }
             'wait for PORTCLOCK LOW

                repeat

                while  (INA [clockpin] == 1)  '(portval  & (|< clockpin))    'wait for clock HI         
             '                  
                repeat

                while  (INA [clockpin] == 0)  '(portval  & (|< clockpin))    'wait for clock Low
            '                   repeat
    

              portval := INA [7..0]
                      
               '    VT100.dec(portval)                         
                '   VT100.out($0d)  ' newline
              

           '                     portval2 := INA 
             '                   while  ((portval2  & (|< clockpin)) == 0)    'test for P25 LOW
               'd2port[xx++] := portval                 
             VT100.poke(xx,portval)

             xx++

             
             ' fpga_buffer[xx++] := portval
              'OUTA[15] := 1
              'OUTA[15] := 0  'you wont see this on a dvm
              
              
                'portval := INA & $ffff
            '      VT100.dec(portval |= |<7 | |<6 | |<5 | |<4 | |<3 | |<2 | |<10 | |<0)
           '       VT100.str(string(" - "))
       {  
          xx := 0
           repeat 40
                                VT100.dec(-((fpga_buffer[xx] & (|< 7)) == 128)) 
                                VT100.dec(-((fpga_buffer[xx] & (|< 6)) == 64)) 
                                VT100.dec(-((fpga_buffer[xx] & (|< 5)) == 32)) 
                                VT100.dec(-((fpga_buffer[xx] & (|< 4)) == 16)) 
                                VT100.dec(-((fpga_buffer[xx] & (|< 3)) == 8)) 
                                VT100.dec(-((fpga_buffer[xx] & (|< 2)) == 4)) 
                                VT100.dec(-((fpga_buffer[xx] & (|< 1)) == 2)) 
                                VT100.dec(-((fpga_buffer[xx] & (|< 0)) == 1)) 
  {
                                'VT100.dec(-((CommandLine[xx] & (|< d1port)) == ($1 << d1port))) 'INA[7])       'for SD_DO  Prop PIN 10
                                VT100.str(string(" - 15: "))
                                VT100.dec((fpga_buffer[xx] & (|< 15)) )
                                VT100.str(string(" - 25:"))
                                VT100.dec(-((fpga_buffer[xx] & (|< 25)) ))'== 33554432 ))
                                VT100.str(string(" - 9:"))
                                VT100.dec(-((fpga_buffer[xx] & (|< 9)) ))'== 512))        'for SD_DO  Prop PIN 9
                                VT100.str(string(" - 10:"))
                                VT100.dec(-((fpga_buffer[xx] & (|< 10)) ))'== 1024))        'for SD_DO  Prop PIN 9
                                VT100.str(string(" - 11:"))
                                VT100.dec(-((fpga_buffer[xx] & (|< 11)) ))'== 1024))        'for SD_DO  Prop PIN 9
                                VT100.str(string("   = "))
                                VT100.dec(fpga_buffer[xx])
   }                              crlf
                                xx++
          }
      'bread += PROPPORT_TEST_LENGTH
      'VT100.dec(bread)                         
      'VT100.out($0d)  ' newline
                                
  {                             VT100.dec(-((portval & (|< 7)) == 128)) 'INA[7])
                                VT100.dec(-((portval & (|< 6)) == 64)) 'INA[7])
                                VT100.dec(-((portval & (|< 5)) == 32)) 'INA[7])
                                VT100.dec(-((portval & (|< 4)) == 16)) 'INA[7])
                                VT100.dec(-((portval & (|< 3)) == 8)) 'INA[7])
                                VT100.dec(-((portval & (|< 2)) == 4)) 'INA[7])
                                VT100.dec(-((portval & (|< 10)) == 1024)) 'INA[7])       'for SD_DO  Prop PIN 10
                                VT100.dec(-((portval & (|< 0)) == 1)) 'INA[7])
                                VT100.str(string(" - "))
                                VT100.dec(-((portval & (|< 9)) == 512)) 'INA[7])       'for SD_DO  Prop PIN 9

  }
  {
        VT100.dec(INA[6])
        VT100.dec(INA[5])
        VT100.dec(INA[4])
        VT100.dec(INA[3])
        VT100.dec(INA[2])
        VT100.dec(INA[10])
        VT100.dec(INA[0])
}
  
        {
        portval1 := INA[d1port]  'data out from sd is also data out from fpga   ' 9 = PIC MOSI / SD_DI / PROP  + fpga Pin 136
        portval2 := INA[d2port]  'data out from sd is also data out from fpga   ' 9 = PIC MOSI / SD_DI / PROP  + fpga Pin 136
        portval3 := INA[d3port]  'data out from sd is also data out from fpga   ' 9 = PIC MOSI / SD_DI / PROP  + fpga Pin 136
   '     portval := INA[_SD_DO]     ' 10 = PIC MISO / SD_DO / PROP  + fpga Pin 134
    '    portval := INA[_SD_CLK]     ' 11 =nc?     PIC SCK ->  fpga Pin 135
        
        printstring(string("- "))
        VT100.dec(portval1)
        VT100.dec(portval2)
        VT100.dec(portval3)
        printstring(string(" -"))
        }
{
        if portval <> oldportval
           oldportval := portval
           diff_flag := 1
}
           
        
   '     VT100.dec(INA[0])

        'VT100.hex()
        
 '       if diff_flag == 1
  '            PrintString(string("DIFF"))
         
 
return


PRI tv_on

                                _VGA_Enabled := false
                                VT100.stop
                                text.start(_TV_Pin)
                                text.startcursor                                     ' start the cursor
                                settvcolors
                                'text.color(%00001000_11111100)                       ' Blue_White  blue =3/4 power 10, white =full                                  
                                text.cursorset(5)                                    ' cursor type 5
                                text.clearscreen                                     ' clear the screen
                                'text.str(string("TV:",13,10))
                                
                                _TV_Enabled := true
                                DisplayBanner  'doDIR
                                text.out(">")
 

PRI vga_on

                                _VGA_Enabled := true
                                VT100.start(16)                                       ' start the vga driver VGA starts on pin 16
                                VT100.startcursor                                     ' start the cursor
                                setvgacolors                       ' Blue_White  blue =3/4 power 10, white =full                                  
                                VT100.cursorset(5)                                    ' cursor type 5
                                VT100.clearscreen                                     ' clear the screen
                                'vt100.str(string("VGA:",13,10))  
                                
                                _TV_Enabled := false
                                text.Close
                                DisplayBanner  'doDIR
                                vt100.out(">")

         

PRI shellLine(prompt)

  PrintString(prompt)


 ' repeat
 '       if key.gotkey <>0         ' scan both the local keyboard and the com port
 '          result:=key.getkey
 '          'text.dec(result)
 '   
 '              PrintStringCR(string("GOT"))
 '              VT100.dec(result)
    

  
  repeat

      result:=0
      repeat
        if key.gotkey <>0         ' scan both the local keyboard and the com port
           result:=key.getkey
           'text.dec(result)
           if result == 204
              result := 0
          ' if result == 194   'UP ARROW key
              ' str.copy(str.builtString(false),CommandLine)

              ' PrintString(@CommandLine)
               'str.stringCopy(whereToPut, whereToGet)
           '   result := 0




           
           if result == 208   'F1 key  superdir
              DisplayBinaryFiles
              result := 0

           if result == 209   'F2 key   normal dir
              doDIR
              result := 0

           if result == 211   'F4 key
              result := \shellCommands(string("BOOT sphinx.eep"))
 
           if result == 212   'F5 key
              result := \shellCommands(string("vgabasic"))

           if result == 213   'F6 key
              result := \shellCommands(string("tvbasic"))          
 

           if result == 216   'F9 key
              result := \shellCommands(string("BOOT fenix.eep"))

           if result == 218   'F11 key
              doFPGA          
 
           if result == 219   'F12 key
              if _VGA_Enabled == false
                 vga_on
              else
                 tv_on              
              result := 0                                  
 
                  
                                       
        if sio.rxavail(0)
          result :=sio.rx(0)  
      until result <>0           ' until something comes in either port
    
    if result==200
      result :=8                ' backspace keycode is 200 but convert to 8
    PrintChar(result)             ' send to vga and to com port
    str.buildString(result)     ' build an input string
  while((result <> 13) and (result <> 10) and (result <> 0))

  return str.trimString(str.builtstring(true))

{
PRI shellDecision(prompt, characterToFind, otherCharacterToFind)

  printstring(prompt)

  repeat

    prompt := com.receivedByte
    result or= ((prompt == characterToFind) or (prompt == otherCharacterToFind))

    if(prompt == com#backspace)
      return false

  while((prompt <> carriage_return) and (prompt <> carriage_return) and (prompt <> com#null))
}
PRI shellDecision(prompt, characterToFind, otherCharacterToFind)

  PrintString(prompt~)  

  repeat
    result := key.getkey
    prompt or= ((result == characterToFind) or (result == otherCharacterToFind))
  while((result <> 13) and (result <> 10) and (result <> 0))  

  return prompt  

PRI programClear(stringPointer)

  ifnot(str.stringCompareCI(string("clear"), stringPointer))
    rtc.pauseForMilliseconds(500)
    printstring(string(_clearScreenCharacter, _homeCursorCharacter))
    abort false

PRI programEcho(stringPointer)

  ifnot(str.stringCompareCI(string("echo"), stringPointer))
    printstring(str.trimString(stringPointer += 5))
    crlf
    abort false

PRI programReboot(stringPointer)

  ifnot(str.stringCompareCI(string("reboot"), stringPointer))
    printstring(string("Rebooting "))

    repeat 3
      rtc.pauseForMilliseconds(500)
      printstring(string(". "))

    rtc.pauseForMilliseconds(500)
    reboot

PRI programHelp(stringPointer)

  ifnot(str.stringCompareCI(string("help"), stringPointer))
    printstring(@shellProgramHelpStrings)
    abort false
 
DAT shellProgramHelpStrings

  byte 13,10
  byte "Command Listing"
  byte 13,10
  byte "F1 SUPERDIR  F2 DIR   F4 SPHINX   F5 TVBASIC"
  byte 13,10
  byte "F6 VGA Basic  F9 CHAMELEON  F12 TV/VGA"
  byte 13,10
    ' byte "<clear>                        - Clear the screen."
 ' byte 13,10
 ' byte "<echo> <string>                - Echo the string argument."
 ' byte 13,10
 ' byte "<reboot>                       - Reboot the propeller chip."
 ' byte 13,10
 ' byte "<help>                         - Show the command listing."
 ' byte 13,10
 ' byte "<mount> <partition>            - Mount the file system."
 ' byte 13,10
 ' byte "<unmount>                      - Unmount the file system."
 ' byte 13,10
  byte "<df> <fast>"'                    - Free sector count. F=Fast. 1 Sector = 512 Bytes"
  byte 13,10
  byte "<du> <fast>"'                    - Used sector count. F=Fast. 1 Sector = 512 Bytes"
  byte 13,10
 ' byte "<ls> <all>                     - List contents of the working directory. A=All."
 ' byte 13,10
 ' byte "<dir>                          - List contents. Includes wildcards eg dir *.exe"
 ' byte 13,10
  byte "<cat> <file> <hex>"'             - Print the ASCII interpreted contents of a file."
  byte 13,10
 ' byte "<cd> <directory>               - Change directory."
 ' byte 13,10
  byte "<chmod> <entry> <attributes>   - Change Attrib: R=R/O, H=Hidden, S=Sys, A=Arch"
  byte 13,10
  byte "<mv> <oldPath> <newPath>"' - Move a file or directory."
  byte 13,10
  byte "<rm/era> <path>"'          - Remove a file or directory."
  byte 13,10
 ' byte "<mkfile> <name>                - Make a new file."
 ' byte 13,10
 ' byte "<mkdir> <name>                 - Make a new directory."
 ' byte 13,10
  byte "<cp> <oldPath> <newPath>"'       - Copy a file."
  byte 13,10
 ' byte 10
 ' byte "<diff> <path> <path>           - Print differences between two files."
 ' byte 13,10
  byte "<boot> <file>"'                  - Reboot the propeller chip from a file."
  byte 13,10
  byte "<filename>"'                     - Reboot and run filename.exe"
  byte 13,10
 ' byte "<format> <partition>           - Format and mount the file system."
 ' byte 13,10
 ' byte "<date>                         - Display the current date and time."
 ' byte 13,10
 ' byte "<time>                         - Change the current date and time."
 ' byte 13,10
'  byte "<set> <byteNumber> <byteValue> - Set the value of a SRAM byte on the RTClock."
'  byte 13,10
'  byte "<get> <byteNumber>             - Get the value of a SRAM byte on the RTClock."
'  byte 13,10
'  byte "<sqw> <frequencyNumber>        - Set the frequecny of the SWQ / OUT pin. (0=1Hz, 1=4096Hz, 2=8192Hz, 3=32768Hz)."
'  byte 13,10
'  byte "<out> <digitalState>           - Set the state of the SWQ / OUT pin. (0=low, 1=high)."
'  byte 13,10
'  byte "<play> <file>                  - Play a WAV file."
'  byte 13,10
'  byte "<tape> <file>                  - Tape a WAV file."
'  byte 13,10
 ' byte "<dump>                         - Dump the ROM font."
 ' byte 13,10
 ' byte "<test>                         - Speed test the file system."
  byte 13,10, 0

PRI programMount(stringPointer)

 
    abort 0

PRI programUnmount(stringPointer)

  ifnot(str.stringCompareCI(string("unmount"), stringPointer))
    taf.unmountPartition
    fat.unmountPartition
    printstringcr(string("Disk ready for removal"))

    abort 0

PRI programFreeSpace(stringPointer)

  ifnot(str.stringCompareCI(string("df"), stringPointer))

    printstring(string("The ", quote))
    printstring(str.trimString(fat.partitionFileSystemType))
    printstring(string(quote, " ", quote))
    printstring(str.trimString(fat.partitionVolumeLabel))
    printstring(string(quote, " parition has "))
    printstring(1 + str.integerToDecimal(fat.partitionCountOfClusters, 10))
    printstring(string(" clusters and "))
    printstring(1 + str.integerToDecimal(fat.partitionDataSectors, 10))
    printstring(string(" total sectors, where each cluster is "))
    printstring(1 + str.integerToDecimal(fat.partitionSectorsPerCluster, 3))
    printstring(string(" sectors large and each sector is "))
    printstring(1 + str.integerToDecimal(fat.partitionBytesPerSector, 3))
    printstringcr(string(" bytes"))
    printstring(string("And there are... please wait... "))
    printstring(1 + str.integerToDecimal(fat.partitionFreeSectorCount(byte[str.tokenizeString(0)]), 10))
    printstringcr(string(" Free Sectors"))

    abort 0

PRI programUsedSpace(stringPointer)

  ifnot(str.stringCompareCI(string("du"), stringPointer))

    printstring(string("The ", quote))
    printstring(str.trimString(fat.partitionFileSystemType))
    printstring(string(quote, " ", quote))
    printstring(str.trimString(fat.partitionVolumeLabel))
    printstring(string(quote, " parition has "))
    printstring(1 + str.integerToDecimal(fat.partitionCountOfClusters, 10))
    printstring(string(" clusters and "))
    printstring(1 + str.integerToDecimal(fat.partitionDataSectors, 10))
    printstring(string(" total sectors where each cluster is "))
    printstring(1 + str.integerToDecimal(fat.partitionSectorsPerCluster, 3))
    printstring(string(" sectors large and each sector is "))
    printstring(1 + str.integerToDecimal(fat.partitionBytesPerSector, 3))
    printstringcr(string(" bytes"))
    printstring(string("And there are... please wait... "))
    printstring(1 + str.integerToDecimal(fat.partitionUsedSectorCount(byte[str.tokenizeString(0)]), 10))
    printstringcr(string(" Used Sectors"))

    abort 0

{
PRI programList(stringPointer) : counter | buffer, flag

  ifnot(str.stringCompareCI(string("ls"), stringPointer))
    stringPointer := str.tokenizeString(0)
    flag := (str.findCharacter(stringPointer, "A") or str.findCharacter(stringPointer, "a"))
    fat.listEntries("W")

    repeat while(buffer := fat.listEntries("N"))
      printstring(buffer)
      ifnot(flag)

        if(++counter // 8)
          PrintChar(horizontal_tab)
        else
          crlf

      else

        if(fat.listIsReadOnly)
          printstring(string(" [ R"))
        else
          printstring(string(" [ _"))

        if(fat.listIsHidden)
          PrintChar("H")
        else
          PrintChar("_")

        if(fat.listIsSystem)
          PrintChar("S")
        else
          PrintChar("_")

        if(fat.listIsDirectory)
          PrintChar("D")
        else
          PrintChar("_")

        if(fat.listIsArchive)
          PrintChar("A")
        else
          PrintChar("_")

        printstring(string(" ] [ "))
        printstring(1 + str.integerToDecimal(fat.listSize, 10))

        printstring(string(" ] [ Accessed "))
        printstring(1 + str.integerToDecimal(fat.listAccessMonth, 2))
        PrintChar("/")
        printstring(1 + str.integerToDecimal(fat.listAccessDay, 2))
        PrintChar("/")
        printstring(1 + str.integerToDecimal(fat.listAccessYear, 4))

        printstring(string(" ] [ Created "))
        printstring(1 + str.integerToDecimal(fat.listCreationHours, 2))
        PrintChar(":")
        printstring(1 + str.integerToDecimal(fat.listCreationMinutes, 2))
        PrintChar(":")
        printstring(1 + str.integerToDecimal(fat.listCreationSeconds, 2))

        PrintChar(" ")
        printstring(1 + str.integerToDecimal(fat.listCreationMonth, 2))
        PrintChar("/")
        printstring(1 + str.integerToDecimal(fat.listCreationDay, 2))
        PrintChar("/")
        printstring(1 + str.integerToDecimal(fat.listCreationYear, 4))

        printstring(string(" ] [ Modified "))
        printstring(1 + str.integerToDecimal(fat.listModificationHours, 2))
        PrintChar(":")
        printstring(1 + str.integerToDecimal(fat.listModificationMinutes, 2))
        PrintChar(":")
        printstring(1 + str.integerToDecimal(fat.listModificationSeconds, 2))

        PrintChar(" ")
        printstring(1 + str.integerToDecimal(fat.listModificationMonth, 2))
        PrintChar("/")
        printstring(1 + str.integerToDecimal(fat.listModificationDay, 2))
        PrintChar("/")
        printstring(1 + str.integerToDecimal(fat.listModificationYear, 4))

        printstringcr(string(" ]"))
    if((counter // 8) and counter) 
      crlf

    abort 0
 }
 
PRI programConcatenate(stringPointer) : counter | buffer, flag

 
    abort 0

PRI programChangeDirectory(stringPointer)

  ifnot(str.stringCompareCI(string("cd"), stringPointer))
    stringPointer := str.tokenizeString(0)
    fat.changeDirectory(stringPointer)
    taf.changeDirectory(stringPointer)
    abort 0

PRI programChangeAttributes(stringPointer)

  ifnot(str.stringCompareCI(string("chmod"), stringPointer))
    fat.changeAttributes(str.tokenizeString(0), str.tokenizeString(0))
    abort 0

PRI programMove(stringPointer)

  ifnot(str.stringCompareCI(string("mv"), stringPointer))
    fat.moveEntry(str.tokenizeString(0), str.tokenizeString(0))
    abort 0

PRI programRemove(stringPointer)

  ifnot(str.stringCompareCI(string("rm"), stringPointer)) 
    fat.deleteEntry(str.tokenizeString(0))
    abort 0

PRI programERA(stringPointer) ' same as ProgramRemove

  ifnot(str.stringCompareCI(string("era"), stringPointer)) 
    fat.deleteEntry(str.tokenizeString(0))
    abort 0

PRI programMakeFile(stringPointer)

  ifnot(str.stringCompareCI(string("mkfile"), stringPointer))
    fat.newFile(str.tokenizeString(0))
    abort 0

PRI programMakeDirectory(stringPointer)

  ifnot(str.stringCompareCI(string("mkdir"), stringPointer))
    fat.newDirectory(str.tokenizeString(0))
    abort 0

PRI programCopy(stringPointer) | sector[128]

  ifnot(str.stringCompareCI(string("cp"), stringPointer))
    fat.openfile(str.tokenizeString(0), "R")
    stringPointer := str.tokenizeString(0)
    taf.newFile(stringPointer)
    taf.openfile(stringPointer, "W")

    repeat
      result := fat.readData(@sector, 512)
      taf.writeData(@sector, result)
    while(result == 512)

    fat.closeFile
    taf.closeFile
    abort 0

PRI programDifference(stringPointer) | byte0, byte1

 
    abort 0

PRI programBoot(stringPointer)

  ifnot(str.stringCompareCI(string("boot"), stringPointer))
      stringPointer := str.tokenizeString(0)        
    'printstring(string("Are you sure you want to reboot from "))
    'printstring(stringPointer)
    'if(shellDecision(string(" - [y]es or [n]o? : "), "Y", "y"))
      fat.bootPartition(stringPointer)

    abort 0


 {
   ' key.stop 'startx(keypin, keypin+1, %100, 40)
 '   printstring(string("Keyboard disabled SWAP MOUSE IN NOW!"))
 '  repeat 10
      ' printstring(".")
     ' delay.pause1ms(1000)
     ' mouse.start(26, 27)
    ' printstring(string("Mouse Started"))
   ' if(shellDecision(string(" - [y]es or [n]o? : "), "Y", "y"))
     }
  
PRI programFormat(stringPointer)

 

    abort 0

PRI programDate(stringPointer)

    
    abort false

PRI programTime(stringPointer) | time[6]


    abort false
    

  

{  
PRI programRamSet(stringPointer)

  ifnot(str.stringCompareCI(string("set"), stringPointer))
    result := rtc.writeSRAM(str.decimalToInteger(str.tokenizeString(0)), str.decimalToInteger(str.tokenizeString(0)))

    stringPointer := string("Failure!", _newLineCharacter)
    if(result)
      stringPointer := string("Success!", _newLineCharacter)

    printstring(stringPointer)
    abort false

PRI programRamGet(stringPointer)

  ifnot(str.stringCompareCI(string("get"), stringPointer))
    printstring(1 + str.integerToDecimal(rtc.readSRAM(str.decimalToInteger(str.tokenizeString(0))), 3))
    PrintChar(_newLineCharacter)
    abort false
}
{
PRI programSQW(stringPointer)

  ifnot(str.stringCompareCI(string("sqw"), stringPointer))
    result := rtc.clockSquareWaveOut(str.decimalToInteger(str.tokenizeString(0)) & 1, 1)

    stringPointer := string("Failure!", _newLineCharacter)
    if(result)
      stringPointer := string("Success!", _newLineCharacter)

    printstring(stringPointer)
    abort false

PRI programOUT(stringPointer)

  ifnot(str.stringCompareCI(string("out"), stringPointer))
    result := rtc.clockSquareWaveOut(0, ((str.decimalToInteger(str.tokenizeString(0)) & 1) << 1))

    stringPointer := string("Failure!", _newLineCharacter)
    if(result)
      stringPointer := string("Success!", _newLineCharacter)

    printstring(stringPointer)
    abort false
}    
{
PRI programPlayWavFile(stringPointer) | numberOfChannels, sampleRate ' Google "WAV format" for info about this function...

  ifnot(str.stringCompareCI(string("play"), stringPointer))
    printstring(string("Please wait...", _newLineCharacter))
    stringPointer := fat.openFile(str.tokenizeString(0), "R")

    if(fat.readLong <> $46_46_49_52)
      abort string("Not RIFF file", _newLineCharacter)

    if((fat.readlong + 8) <> fat.fileSize)
      abort string("Chunk size incorrect", _newLineCharacter)

    if(fat.readLong <> $45_56_41_57)
      abort string("Not WAVE file", _newLineCharacter)

    if(fat.readLong <> $20_74_6D_66)
      abort string(quote, "fmt ", quote, " missing",  _newLineCharacter)

    if(fat.readLong <> 16)
      abort string("Subchunk 1 size incorrect", _newLineCharacter)

    if(fat.readShort <> 1)
      abort string("Not LPCM file", _newLinecharacter)

    dac.numberOfChannelsSetup(numberOfChannels := fat.readShort)
    dac.sampleRateSetup(sampleRate := fat.readLong)

    fat.fileSeek(34)
    dac.bitsPerSampleSetup(result := fat.readShort)
    dac.sampleSignSetup(result == 16)

    fat.fileSeek(28)

    if(fat.readLong <> (sampleRate * numberOfChannels * result / 8))
      abort string("Byte rate incorrect", _newLineCharacter)

    if(fat.readShort <> (numberOfChannels * result / 8))
      abort string("Block align incorrect", _newLineCharacter)

    fat.fileSeek(36)

    if(fat.readLong <> $61_74_61_64)
      abort string(quote, "data", quote, " missing",  _newLineCharacter)

    result := fat.readlong
    if((result + constant(36 + 8)) <> fat.fileSize)
      abort string("Subchunk 2 size incorrect", _newLineCharacter)

    printstring(string("Now playing "))
    printstring(stringPointer)
    printstring(string(_newLineCharacter, "Press enter to quit ", _newLineCharacter))

    dac.startPlayer
    scopeSwtich := true

    repeat ((result + 511) / 512)
      fat.readData(dac.transferData, 512)

      if(com.receivedNumber)
        result := com.receivedByte
        if((result == carriage_return) or (result == carriage_return) or (result == com#null))
          printstring(string("Quiting", _newLineCharacter))
          quit

    scopeSwtich := false
    dac.stopPlayer
    dac.clearData
    fat.closeFile
    abort 0
}    
{
PRI programTapeWavFile(stringPointer) ' Google "WAV format" for info about this function...

  ifnot(str.stringCompareCI(string("tape"), stringPointer))
    printstring(string("Please wait...", _newLineCharacter))

    stringPointer := str.tokenizeString(0)
    fat.newFile(stringPointer)
    stringPointer := fat.openFile(stringPointer, "W")

    printstring(string("Now taping "))
    printstring(stringPointer)
    printstring(string(_newLineCharacter, "Press enter to save ", _newLineCharacter))

    fat.writeString(string("RIFF____WAVEfmt "))
    fat.writeLong(16)
    fat.writeShort(1)
    fat.writeShort(1)
    fat.writeLong(16_000)
    fat.writeLong(16_000)
    fat.writeShort(1)
    fat.writeShort(8)
    fat.writeString(string("data____"))

    adc.sampleRateSetup(16_000)
    adc.numberOfChannelsSetup(1)
    adc.bitsPerSampleSetup(8)
    adc.sampleSignSetup(0)

    adc.clearData
    repeat while(result < (posx - constant(36 + 8)))
      fat.writeData(adc.transferData, 512)
      result += 512

      if(com.receivedNumber)
        stringPointer := com.receivedByte
        if((stringPointer == carriage_return) or (stringPointer == carriage_return) or (stringPointer == com#null))
          printstring(string("Saving", _newLineCharacter))
          quit

    fat.fileSeek(40)
    fat.writeLong(result)
    fat.fileSeek(4)
    fat.writeLong(result + 36)

    fat.closeFile
    abort 0
}
PRI programDump(stringPointer) | outsideCounter, insideCounter

  ifnot(str.stringCompareCI(string("dump"), stringPointer))
    fat.openFile(fat.newFile(string("P8X32A.TXT")), "W")

    fat.writeString(string("P8X32A Character Set", carriage_return, line_feed, carriage_return, line_feed))
    repeat outsideCounter from 0 to 255

      printstring(string("Dumping character #"))
      printstringcr(1 + str.integerToDecimal(outsideCounter, 3))

      fat.writeString(string("Character #"))
      fat.writeString(1 + str.integerToDecimal(outsideCounter, 3))
      fat.writeString(string(carriage_return, carriage_return, carriage_return, carriage_return))

      repeat result from 0 to 31
        repeat insideCounter from (outsideCounter & 1) to 31 step 2

          if(long[32_768][result + ((outsideCounter >> 1) << 5)] & (|<insideCounter))
            fat.writeByte(".")
          else
            fat.writeByte(" ")

        fat.writeString(string(carriage_return, carriage_return))
      fat.writeString(string(carriage_return, carriage_return))

    fat.closeFile
    abort 0

PRI programTest(stringPointer) | counter, buffer

 
   
    abort 0

PRI startTest(path, mode, message)
 
  return cnt

PRI stopTest(mode, count, cycles)

 
  
    abort false

PRI multiplyDivide(dividen, divisor) | productHigh, productLow

  productHigh := clkfreq ** dividen
  productLow := clkfreq * dividen
  if(productHigh => divisor)
    return posx

  repeat 32

    dividen := (productHigh < 0)
    productHigh := ((productHigh << 1) + (productLow >> 31))
    productLow <<= 1
    result <<= 1

    if((productHigh => divisor) or dividen)
      productHigh -= divisor
      result += 1
{
PRI scope | displayPointer, currentDisplay

  bmp.displayColor(0, _VGA_BG_Color)
  bmp.displayColor(1, _VGA_FG_Color)
  displayPointer := constant((_VGA_H_Res * _VGA_V_Res) / 32)
  repeat

    bmp.displayWait(1)
    bmp.displayPointer(@scopeHeap[displayPointer & currentDisplay])
    not currentDisplay
    bmp.displayClear(0, @scopeHeap[displayPointer & currentDisplay])

    repeat result from 0 to constant(_VGA_H_Res - 1)

      if(scopeSwtich)

        bmp.plotPixel( 1, {
                     } result, {
                     } (constant(_VGA_V_Res / 2) + (dac.leftChannelOutput ~> constant(16 - (>|_VGA_V_Res)))), {
                     } @scopeHeap[displayPointer & currentDisplay])
      else

        bmp.plotPixel( 1, {
                     } result, {
                     } (constant(_VGA_V_Res / 2) + (adc.leftChannelInput ~> constant(16 - (>|_VGA_V_Res)))), {
                     } @scopeHeap[displayPointer & currentDisplay])
}                     

PUB PrintStringCR(pstring)' sends pstring to the vga and serial port
     PrintString(pstring)                               ' print the string  
     crlf

PUB PrintString(pstring)' sends pstring to the vga and serial port with no CRLF
    if (_TV_Enabled)
      text.str(pstring)
    if (_VGA_Enabled)  
      vt100.str(pstring)                                 ' send to vga screen
  '  if (_Serial_Enabled)   
    sio.str(0,pstring)                                 ' send to com port
'    if (_lcd_Enabled)
'       lcd.str(pstring)                                   ' send to 20x4 lCD display

PUB PrintChar(c) ' sends c to vga and serial port
    if (_TV_Enabled)
      text.out(c)
    if (_VGA_Enabled)
      vt100.out(c)                                        ' send to vga
  '  if (_Serial_Enabled)
    sio.tx(0,c)                                         ' send to com port
'    if (_lcd_Enabled)
'      LCD.out(c)                                          ' send to LCD display      
PUB CRLF
    PrintChar(13)                                        ' send to vga
    PrintChar(10)                                        ' send to vga

PUB PrintDecimal(number)                                ' print the decimal value, useful for debuggin
     PrintString(str.integerToDecimal(number, 10))   

PRI DisplayBinaryFiles | buffer,counter
 ' PrintString(string("Use the BOOT command to run the following binary Spin programs/emulations:"))

 'partitionVolumeIdentification
 'partitionVolumeLabel
 'partitionFileSystemType
 'partitionBytesPerSector
 'partitionSectorsPerCluster
 ' buffer := fat.curDIR
  'PrintStringCR(buffer)
 

  crlf
  fat.listEntries("W")   
  PrintStringCR(string("EXE:"))
  counter:=0
  repeat while(buffer := fat.listEntries("N"))   
      buffer := str.trimstring(buffer)   
 '     if str.endswithstring(buffer,string(".BIN")) == -1 or str.endswithstring(buffer,string(".EXE")) == -1
      if str.endswithstring(buffer,string(".EXE")) == -1
        PrintString(buffer)
         counter++                                       ' add one to counter
        repeat 13-str.len(buffer)                 ' add spaces so columns line up
            printchar(" ")                              ' print space
      if counter == 6                                   ' new line
        counter :=0
  crlf
  crlf
  counter:=0
  PrintStringCR(string("BIN:"))
  repeat while(buffer := fat.listEntries("N"))   
      buffer := str.trimstring(buffer)   
 '     if str.endswithstring(buffer,string(".BIN")) == -1 or str.endswithstring(buffer,string(".EXE")) == -1
      if str.endswithstring(buffer,string(".BIN")) == -1
        PrintString(buffer)
        'crlf
        counter++                                       ' add one to counter
        repeat 13-str.len(buffer)                 ' add spaces so columns line up
            printchar(" ")                              ' print space
      if counter == 6                                   ' new line
        counter :=0
 
  crlf
  crlf
  counter:=0
 PrintStringCR(string("Dir:"))
  repeat while(buffer := fat.listEntries("N") )   
      buffer := str.trimstring(buffer)   
 '     if str.endswithstring(buffer,string(".BIN")) == -1 or str.endswithstring(buffer,string(".EXE")) == -1
      if  fat.listIsDirectory 
        PrintString(buffer)
         'crlf
         counter++                                       ' add one to counter
        repeat 13-str.len(buffer)                 ' add spaces so columns line up
            printchar(" ")                              ' print space
      if counter == 6                                   ' new line
        counter :=0

  crlf
  crlf
    PrintChar(">")

PRI ProgramDir(StringPointer) | buffer,counter,match
  ifnot(str.stringCompareCI(string("dir"), stringPointer))
    stringPointer := str.tokenizeString(0)              ' get the *.exe bit
    str.copy(stringpointer,@lineoftext1)                ' move to lineoftext1
    str.mid(@lineoftext1,@lineoftext2,str.instr(@lineoftext1,"."),4) ' get string from . to end = extension
    counter:=0
    crlf
    fat.listEntries("W")   
    repeat while(buffer := fat.listEntries("N"))
      str.copy(buffer,@LineOfText1)                ' copy filename to LineOfText
      str.trimstring(@lineoftext1)
      str.mid(@lineoftext1,@lineoftext3,str.instr(@lineoftext1,"."),4) ' get string from . to end = extension     
      match := false                                    ' setup for below
      if str.len(@lineoftext2) == 0
        match := true                                   ' no extension so always print it
      else
        ifnot str.stringcompareci(@lineoftext2,@lineoftext3) ' reverse logic ?!
          match := true                                 ' found a match
      if match == true
        PrintString(@lineoftext1)                       ' print file name
        counter++                                       ' add one to counter
        repeat 13-str.len(@lineoftext1)                 ' add spaces so columns line up
            printchar(" ")                              ' print space
      if counter == 6                                   ' new line
        counter :=0
        crlf 
    crlf
    abort 0                                             ' so knows a command was run

PRI ProgramCommand(StringPointer) | buffer,i ' look for .exe files (ie .binary files renamed to .exe) and if found, run the program
 'PrintString(StringPointer)

    fat.listEntries("W")
    str.copy(stringpointer,@lineoftext2)                ' copy the command to lineoftext2
    str.stringConcatenate(@lineoftext2, string(".exe")) ' add extension for executable files to lineoftext2
     repeat while(buffer := fat.listEntries("N"))
       str.copy(buffer,@LineOfText1)                    ' copy filename to LineOfText1
       str.trimstring(@lineoftext1)                     ' remove any leading/trailing spaces  
       'PrintString(@lineoftext1)
      ifnot str.stringcompareci(@lineoftext1,@lineoftext2)' does it match? (ignore case)
         str.copy(buffer,@lineoftext3)                  ' can't use "buffer" as it gets overwritten
         'printstringcr(string("Saving command line in COMMAND.TXT and running program"))
         'printstring(string("Command line: "))
         'printstring(@commandline)
          ' above commented out as 1) about to blank the screen, 2) debugged and 3) if running xmodem don't want any further data on the serial lines
          ' possibly could put this output back if use the vga screen only.                   
         result := \fat.newFile(string("COMMAND.TXT")) ' All aborts traps must have "variable := \function" setup.
         if(fat.partitionError == fat#Entry_Already_Exist)  ' file already exists
            result := \fat.deleteEntry(string("COMMAND.TXT"))    ' delete the old file
            result := \fat.newfile(string("COMMAND.TXT")) ' recreate the file
         result := \fat.openFile(string("COMMAND.TXT"), "W") ' create file and open file
         result := \fat.writestring(@commandline)       ' store the command line as it was typed
         result := \fat.closefile                       ' close the file
         result := \fat.bootpartition(@lineoftext3)     ' reboot


' ***************************************************************************************
      'printstring(@lineoftext1)                         ' testing string functions
      'str.left(@lineoftext1,@lineoftext2,3)  ' find leftmost characters in a string
      'printstring(@lineoftext2)
      'str.trimstring(@lineoftext1)
      'printstring(@lineoftext1)
      'str.trimstring(@lineoftext1)
      'str.mid(@lineoftext1,@lineoftext2,4,2) ' find middle characters in a string
      'printstring(@lineoftext2)
      'printstring(str.integertodecimal(str.len(@lineoftext2),5))
      'str.copy(string("hello"),@lineoftext1) ' copy fixed value into a string
      'printstring(@lineoftext1)
      'str.str(@lineoftext1,55) ' decimal to string with no leading zeros
      'printstring(@lineoftext1)
      'str.stringfill(@lineoftext1,10,65)
      'printstring(@lineoftext1)
      'str.str(@lineoftext1,1234)' convert to string
      'str.str(@lineoftext1,str.decimaltointeger(@lineoftext1)) ' convert back
      'printstring(@lineoftext1)
      ' str.left(@lineoftext1,@lineoftext2,str.len(@lineoftext1)-4) ' remove extension
      ' printstring(@lineoftext2) ' print it out
 {
        
DAT
        org 0

toggle  mov dira, pin 
        mov time, cnt
        add time, #9 

:loop   waitcnt time, delay
        xor outa, pin
        jmp #:loop
         
        pin long |<1
        delay long 6_000_000
        time res 1 
  }
         
{{

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                  TERMS OF USE: MIT License
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation
// files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy,
// modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the
// Software is furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in all copies or substantial portions of the
// Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
// WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
// COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
// ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
}}